[arch-commits] Commit in libxml2/repos (4 files)
Jan Steffens
heftig at gemini.archlinux.org
Tue Dec 21 20:25:54 UTC 2021
Date: Tuesday, December 21, 2021 @ 20:25:54
Author: heftig
Revision: 432888
archrelease: copy trunk to testing-x86_64
Added:
libxml2/repos/testing-x86_64/
libxml2/repos/testing-x86_64/PKGBUILD
(from rev 432887, libxml2/trunk/PKGBUILD)
libxml2/repos/testing-x86_64/libxml2-2.9.8-python3-unicode-errors.patch
(from rev 432887, libxml2/trunk/libxml2-2.9.8-python3-unicode-errors.patch)
libxml2/repos/testing-x86_64/no-fuzz.patch
(from rev 432887, libxml2/trunk/no-fuzz.patch)
--------------------------------------------+
PKGBUILD | 88 +++++++++++++++++++++++++++
libxml2-2.9.8-python3-unicode-errors.patch | 34 ++++++++++
no-fuzz.patch | 24 +++++++
3 files changed, 146 insertions(+)
Copied: libxml2/repos/testing-x86_64/PKGBUILD (from rev 432887, libxml2/trunk/PKGBUILD)
===================================================================
--- testing-x86_64/PKGBUILD (rev 0)
+++ testing-x86_64/PKGBUILD 2021-12-21 20:25:54 UTC (rev 432888)
@@ -0,0 +1,88 @@
+# Maintainer: Levente Polyak <anthraxx[at]archlinux[dot]org>
+# Maintainer: Jan de Groot <jgc at archlinux.org>
+# Contributor: Tom Gundersen <teg at jklm.no>
+# Contributor: John Proctor <jproctor at prium.net>
+
+pkgname=libxml2
+pkgver=2.9.12
+pkgrel=6
+pkgdesc='XML parsing library, version 2'
+url='http://www.xmlsoft.org/'
+arch=(x86_64)
+license=(MIT)
+depends=(zlib readline ncurses xz icu)
+makedepends=(python git)
+_commit=b48e77cf4f6fa0792c5f4b639707a2b0675e461b # tags/v2.9.12^0
+source=("git+https://gitlab.gnome.org/GNOME/libxml2.git#commit=$_commit"
+ libxml2-2.9.8-python3-unicode-errors.patch
+ no-fuzz.patch # Do not run fuzzing tests
+ https://www.w3.org/XML/Test/xmlts20130923.tar.gz)
+sha256sums=('SKIP'
+ '37eb81a8ec6929eed1514e891bff2dd05b450bcf0c712153880c485b7366c17c'
+ '163655aba312c237a234a82d64b71a65bd9d1d901e176d443e3e3ac64f3b1b32'
+ '9b61db9f5dbffa545f4b8d78422167083a8568c59bd1129f94138f936cf6fc1f')
+
+pkgver() {
+ cd $pkgname
+ git describe --tags | sed 's/-rc/rc/;s/^v//;s/\([^-]*-g\)/r\1/;s/-/./g'
+}
+
+prepare() {
+ mkdir build
+
+ # Use xmlconf from conformance test suite
+ ln -s xmlconf build/xmlconf
+
+ cd $pkgname
+
+ # Work around lxml API abuse
+ git cherry-pick -n 85b1792e37b131e7a51af98a37f92472e8de5f3f
+ # Fix regression in xmlNodeDumpOutputInternal
+ git cherry-pick -n 13ad8736d294536da4cbcd70a96b0a2fbf47070c
+ # Fix XPath recursion limit
+ git cherry-pick -n 3e1aad4fe584747fd7d17cc7b2863a78e2d21a77
+ # Fix whitespace when serializing empty HTML documents
+ git cherry-pick -n 92d9ab4c28842a09ca2b76d3ff2f933e01b6cd6f
+
+ # Take patches from https://src.fedoraproject.org/rpms/libxml2/tree/master
+ local src
+ for src in "${source[@]}"; do
+ src="${src%%::*}"
+ src="${src##*/}"
+ [[ $src = *.patch ]] || continue
+ echo "Applying patch $src..."
+ git apply -3 "../$src"
+ done
+
+ autoreconf -fiv
+}
+
+build() (
+ cd build
+
+ ../$pkgname/configure \
+ --prefix=/usr \
+ --with-threads \
+ --with-history \
+ --with-python=/usr/bin/python \
+ --with-icu
+ sed -i -e 's/ -shared / -Wl,-O1,--as-needed\0 /g' libtool
+ make
+
+ find doc -type f -exec chmod 0644 {} +
+)
+
+check() {
+ make -C build check
+}
+
+package() {
+ make -C build DESTDIR="$pkgdir" install
+
+ python -m compileall -d /usr/lib "$pkgdir/usr/lib"
+ python -O -m compileall -d /usr/lib "$pkgdir/usr/lib"
+
+ install -Dm 644 build/COPYING -t "$pkgdir/usr/share/licenses/$pkgname"
+}
+
+# vim: ts=2 sw=2 et:
Copied: libxml2/repos/testing-x86_64/libxml2-2.9.8-python3-unicode-errors.patch (from rev 432887, libxml2/trunk/libxml2-2.9.8-python3-unicode-errors.patch)
===================================================================
--- testing-x86_64/libxml2-2.9.8-python3-unicode-errors.patch (rev 0)
+++ testing-x86_64/libxml2-2.9.8-python3-unicode-errors.patch 2021-12-21 20:25:54 UTC (rev 432888)
@@ -0,0 +1,34 @@
+Index: libxml2-2.9.5/python/libxml.c
+===================================================================
+--- libxml2-2.9.5.orig/python/libxml.c
++++ libxml2-2.9.5/python/libxml.c
+@@ -1620,6 +1620,7 @@ libxml_xmlErrorFuncHandler(ATTRIBUTE_UNU
+ PyObject *message;
+ PyObject *result;
+ char str[1000];
++ unsigned char *ptr = (unsigned char *)str;
+
+ #ifdef DEBUG_ERROR
+ printf("libxml_xmlErrorFuncHandler(%p, %s, ...) called\n", ctx, msg);
+@@ -1636,12 +1637,20 @@ libxml_xmlErrorFuncHandler(ATTRIBUTE_UNU
+ str[999] = 0;
+ va_end(ap);
+
++#if PY_MAJOR_VERSION >= 3
++ /* Ensure the error string doesn't start at UTF8 continuation. */
++ while (*ptr && (*ptr & 0xc0) == 0x80)
++ ptr++;
++#endif
++
+ list = PyTuple_New(2);
+ PyTuple_SetItem(list, 0, libxml_xmlPythonErrorFuncCtxt);
+ Py_XINCREF(libxml_xmlPythonErrorFuncCtxt);
+- message = libxml_charPtrConstWrap(str);
++ message = libxml_charPtrConstWrap(ptr);
+ PyTuple_SetItem(list, 1, message);
+ result = PyEval_CallObject(libxml_xmlPythonErrorFuncHandler, list);
++ /* Forget any errors caused in the error handler. */
++ PyErr_Clear();
+ Py_XDECREF(list);
+ Py_XDECREF(result);
+ }
Copied: libxml2/repos/testing-x86_64/no-fuzz.patch (from rev 432887, libxml2/trunk/no-fuzz.patch)
===================================================================
--- testing-x86_64/no-fuzz.patch (rev 0)
+++ testing-x86_64/no-fuzz.patch 2021-12-21 20:25:54 UTC (rev 432888)
@@ -0,0 +1,24 @@
+diff --git i/Makefile.am w/Makefile.am
+index a9284b95..3d7b344d 100644
+--- i/Makefile.am
++++ w/Makefile.am
+@@ -2,9 +2,9 @@
+
+ ACLOCAL_AMFLAGS = -I m4
+
+-SUBDIRS = include . doc example fuzz xstc $(PYTHON_SUBDIR)
++SUBDIRS = include . doc example xstc $(PYTHON_SUBDIR)
+
+-DIST_SUBDIRS = include . doc example fuzz python xstc
++DIST_SUBDIRS = include . doc example python xstc
+
+ AM_CPPFLAGS = -I$(top_builddir)/include -I$(srcdir)/include
+
+@@ -210,7 +210,6 @@ runtests: runtest$(EXEEXT) testrecurse$(EXEEXT) testapi$(EXEEXT) \
+ $(CHECKER) ./runxmlconf$(EXEEXT)
+ @(if [ "$(PYTHON_SUBDIR)" != "" ] ; then cd python ; \
+ $(MAKE) tests ; fi)
+- @cd fuzz; $(MAKE) tests
+
+ check: all runtests
+
More information about the arch-commits
mailing list